Module Compare

    Sub Main()
        'create array of 5 integers
        Dim a() As Integer = {4, 2, 5, 1, 3}

        BubbleSort(1, a)    'sort using 1 as ascending order
        MsgBox(a(0) & a(1) & a(2) & a(3) & a(4), , "Ascending")

        BubbleSort(2, a)    'sort using 2 as descending order
        MsgBox(a(0) & a(1) & a(2) & a(3) & a(4), , "Descending")
    End Sub

    'declare delegate function to compare two integers and return a bool
    Delegate Function CompareFunc(ByVal x As Integer, ByVal y As Integer) As Boolean

    'create method to compare for ascending numbers
    Function CompareAscending(ByVal x As Integer, ByVal y As Integer) As Boolean
        Return (y > x)
    End Function

    'create method to compare for descending numbers
    Function CompareDescending(ByVal x As Integer, ByVal y As Integer) As Boolean
        Return (x > y)
    End Function

    'sort the numbers in an array
    Sub BubbleSort(ByVal sortType As Integer, ByVal intArray() As Integer)
        'sortType specifies ascending or descending

        Dim I, J, Value, Temp As Integer
        Dim delDelegate As CompareFunc  'declare delegate

        If sortType = 1 Then
            'if ascending, create ascending delegate
            delDelegate = New CompareFunc(AddressOf CompareAscending)
        Else
            'if descending, create descending delegate
            delDelegate = New CompareFunc(AddressOf CompareDescending)
        End If

        For I = 0 To UBound(intArray)
            Value = intArray(I)
            For J = I + 1 To UBound(intArray)
                'call delegate via Invoke to test value
                If delDelegate.Invoke(intArray(J), Value) Then
                    intArray(I) = intArray(J)
                    intArray(J) = Value
                    Value = intArray(I)
                End If
            Next J
        Next I
    End Sub

End Module
